'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var renderLoadingInfo = function renderLoadingInfo(startStatus) {
  var video = startStatus.video,
      danmuku = startStatus.danmuku,
      controller = startStatus.controller;

  var tips = ['', '', '[完成]', '[失败]'];
  return _react2.default.createElement(
    'div',
    { className: 'loading-tips-container' },
    _react2.default.createElement(
      'ul',
      null,
      _react2.default.createElement(
        'li',
        { style: { visibility: '' + (video === 0 ? 'hidden' : 'visible') } },
        '\u89C6\u9891\u6838\u52A8\u529B\u6CE8\u5165...',
        _react2.default.createElement(
          'i',
          null,
          tips[video]
        )
      ),
      _react2.default.createElement(
        'li',
        { style: { visibility: '' + (danmuku === 0 ? 'hidden' : 'visible') } },
        '\u4E3B\u6B66\u5668\u5F39\u5E55\u88C5\u586B...',
        _react2.default.createElement(
          'i',
          null,
          tips[danmuku]
        )
      ),
      _react2.default.createElement(
        'li',
        { style: { visibility: '' + (controller === 0 ? 'hidden' : 'visible') } },
        '\u9A7E\u9A76\u8231\u795E\u7ECF\u540C\u6B65...',
        _react2.default.createElement(
          'i',
          null,
          tips[controller]
        )
      ),
      _react2.default.createElement(
        'li',
        { style: { visibility: '' + (controller === 0 || controller === 1 ? 'hidden' : 'visible') } },
        video === 3 ? '初号机启动失败.' : '初号机就绪.'
      )
    )
  );
};

var Start = function Start(props) {
  var startStatus = props.startStatus,
      showStart = props.showStart;

  var svgHtml = '<use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#loading_start" />';
  return _react2.default.createElement(
    'div',
    {
      className: 'player-loading',
      style: { display: '' + (showStart ? 'block' : 'none') }
    },
    _react2.default.createElement('svg', { className: 'loading-icon', version: '1.1', fill: 'white', dangerouslySetInnerHTML: { __html: svgHtml } }),
    renderLoadingInfo(startStatus)
  );
};

Start.displayName = 'IceVideoStart';
Start.propTypes = {
  showStart: _react.PropTypes.bool.isRequired,
  startStatus: _react.PropTypes.shape({
    video: _react.PropTypes.oneOf([0, 1, 2, 3]),
    barrage: _react.PropTypes.oneOf([0, 1, 2, 3]),
    controller: _react.PropTypes.oneOf([0, 1, 2, 3])
  })
};

var _default = Start;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(renderLoadingInfo, 'renderLoadingInfo', 'src/component/Start.js');

  __REACT_HOT_LOADER__.register(Start, 'Start', 'src/component/Start.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/Start.js');
}();

;