'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var colorGrups = ['white', 'black', 'ghostwhite', 'snow', 'whitesmoke', 'silver', 'darkgray', 'grey', 'dimgray', 'lavender', 'skyblue', 'royalblue', 'mediumblue', 'purple', 'blue', 'steelblue', 'darkblue', 'navy', 'blueviolet', 'lightpink', 'pink', 'hotpink', 'peachpuff', 'deeppink', 'mediumvioletred', 'red', 'crimson', 'firebrick', 'darkred', 'aquamarine', 'mediumaquamarine', 'cyan', 'springgreen', 'lightgreen', 'seagreen', 'forestgreen', 'limegreen', 'green', 'darkgreen', 'ivory', 'wheat', 'lemonchiffon', 'khaki', 'bisque', 'lightgoldenrodyellow', 'Yellow', 'gold', 'goldenrod', 'orange', 'tan', 'lightcoral', 'peru', 'olivedrab', 'chocolate', 'sienna', 'brown', 'saddlebrown', 'maroon'];

var Controller = function (_Component) {
  _inherits(Controller, _Component);

  function Controller(props) {
    _classCallCheck(this, Controller);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.getLeft = function () {
      return _this.__getLeft__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setMenu = function () {
      return _this.__setMenu__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setOpacity = function () {
      return _this.__setOpacity__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setOnOff = function () {
      return _this.__setOnOff__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.hanldeOnDanmuku = function () {
      return _this.__hanldeOnDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnIndicatorMouseDown = function () {
      return _this.__handleOnIndicatorMouseDown__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnOpacityMouseMove = function () {
      return _this.__handleOnOpacityMouseMove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnOpacityBarClick = function () {
      return _this.__handleOnOpacityBarClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.computeLeftX = function () {
      return _this.__computeLeftX__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.state = {
      menu: 'danmuku', // danmuku player
      dragOpacity: false,
      dragOpacityWidth: 0
    };
    return _this;
  }

  Controller.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return nextProps !== this.props || nextState !== this.state;
  };

  Controller.prototype.__getLeft__REACT_HOT_LOADER__ = function __getLeft__REACT_HOT_LOADER__(element) {
    var left = element.offsetLeft;
    if (element.offsetParent !== null) {
      left += this.getLeft(element.offsetParent);
    }
    return left;
  };

  Controller.prototype.__setMenu__REACT_HOT_LOADER__ = function __setMenu__REACT_HOT_LOADER__(name) {
    var _this2 = this;

    return function () {
      _this2.setState({ menu: name });
    };
  };

  Controller.prototype.__setOpacity__REACT_HOT_LOADER__ = function __setOpacity__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.state.dragOpacity) {
      this.setState({
        dragOpacity: false
      });
    }
  };

  Controller.prototype.__setOnOff__REACT_HOT_LOADER__ = function __setOnOff__REACT_HOT_LOADER__(config) {
    var _this3 = this;

    return function () {
      _this3.props.setPlayerConfig(config);
    };
  };

  Controller.prototype.__hanldeOnDanmuku__REACT_HOT_LOADER__ = function __hanldeOnDanmuku__REACT_HOT_LOADER__(config) {
    var _this4 = this;

    return function () {
      _this4.props.setDanmukuConfig(config);
    };
  };

  Controller.prototype.__handleOnIndicatorMouseDown__REACT_HOT_LOADER__ = function __handleOnIndicatorMouseDown__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var offsetWidth = this.opacityBar.offsetWidth;

    var left = this.getLeft(this.opacityBar);
    this.setState({
      dragOpacity: true,
      dragOpacityWidth: this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth
    });
  };

  Controller.prototype.__handleOnOpacityMouseMove__REACT_HOT_LOADER__ = function __handleOnOpacityMouseMove__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.state.dragOpacity) {
      var offsetWidth = this.opacityBar.offsetWidth;

      var left = this.getLeft(this.opacityBar);
      var result = this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth;
      this.setState({
        dragOpacityWidth: result
      });
      this.props.setPlayerConfig({ opacity: result });
    }
  };

  Controller.prototype.__handleOnOpacityBarClick__REACT_HOT_LOADER__ = function __handleOnOpacityBarClick__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    e.stopPropagation();
    var offsetWidth = this.opacityBar.offsetWidth;

    var left = this.getLeft(this.opacityBar);
    this.props.setPlayerConfig({
      opacity: this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth
    });
  };

  Controller.prototype.__computeLeftX__REACT_HOT_LOADER__ = function __computeLeftX__REACT_HOT_LOADER__(X, left, width) {
    var leftX = void 0;
    if (X < left) {
      leftX = 0;
    } else if (X > left + width) {
      leftX = width;
    } else {
      leftX = X - left;
    }
    return leftX;
  };

  Controller.prototype.render = function render() {
    var _this5 = this;

    var _state = this.state,
        menu = _state.menu,
        dragOpacity = _state.dragOpacity,
        dragOpacityWidth = _state.dragOpacityWidth;
    var _props$danmukuConfig = this.props.danmukuConfig,
        model = _props$danmukuConfig.model,
        fontSize = _props$danmukuConfig.fontSize,
        fontColor = _props$danmukuConfig.fontColor;
    var _props$playerConfig = this.props.playerConfig,
        opacity = _props$playerConfig.opacity,
        onOff = _props$playerConfig.onOff;

    var rollIcon = '<use class="model-roll-icon" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#danmuku-roll" />';
    var topIcon = '<use class="model-top-icon" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#danmuku-top" />';
    var bottomIcon = '<use class="model-bottom-icon" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#danmuku-bottom" />';
    return _react2.default.createElement(
      'div',
      { className: 'video-config-container' },
      _react2.default.createElement(
        'div',
        { className: 'video-config', 'data-status': menu },
        _react2.default.createElement(
          'div',
          { className: 'video-config-bar' },
          _react2.default.createElement(
            'ul',
            null,
            _react2.default.createElement(
              'li',
              { className: 'danmuku-li', onClick: this.setMenu('danmuku') },
              '\u5F39\u5E55\u8BBE\u7F6E'
            ),
            _react2.default.createElement(
              'li',
              { className: 'player-li', onClick: this.setMenu('player') },
              '\u64AD\u653E\u5668\u8BBE\u7F6E'
            )
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'video-config-content' },
          _react2.default.createElement(
            'div',
            { className: 'config-group danmuku-group' },
            _react2.default.createElement(
              'div',
              { className: 'config-item danmuku-font', 'data-status': fontSize },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u5B57\u53F7'
              ),
              _react2.default.createElement(
                'div',
                { className: 'row-selection' },
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name small', onClick: this.hanldeOnDanmuku({ fontSize: 'small' }) },
                  '\u5C0F'
                ),
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name middle', onClick: this.hanldeOnDanmuku({ fontSize: 'middle' }) },
                  '\u4E2D'
                ),
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name large', onClick: this.hanldeOnDanmuku({ fontSize: 'large' }) },
                  '\u5927'
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'config-item danmuku-model', 'data-status': model },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u6A21\u5F0F'
              ),
              _react2.default.createElement(
                'div',
                { className: 'row-selection' },
                _react2.default.createElement(
                  'div',
                  { className: 'selection-span model-roll', onClick: this.hanldeOnDanmuku({ model: 'roll' }) },
                  _react2.default.createElement('svg', { className: 'model-svg model-roll-svg', version: '1.1', viewBox: '0 0 48 48', dangerouslySetInnerHTML: { __html: rollIcon } }),
                  _react2.default.createElement(
                    'span',
                    { className: 'selection-name roll' },
                    '\u6EDA\u52A8'
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'selection-span model-top', onClick: this.hanldeOnDanmuku({ model: 'top' }) },
                  _react2.default.createElement('svg', { className: 'model-svg model-top-svg', version: '1.1', viewBox: '0 0 48 48', dangerouslySetInnerHTML: { __html: topIcon } }),
                  _react2.default.createElement(
                    'span',
                    { className: 'selection-name top' },
                    '\u9876\u90E8'
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'selection-span model-bottom', onClick: this.hanldeOnDanmuku({ model: 'bottom' }) },
                  _react2.default.createElement('svg', { className: 'model-svg model-bottom-svg', version: '1.1', viewBox: '0 0 48 48', dangerouslySetInnerHTML: { __html: bottomIcon } }),
                  _react2.default.createElement(
                    'span',
                    { className: 'selection-name bottom' },
                    '\u5E95\u90E8'
                  )
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'config-item danmuku-color', 'data-status': fontColor },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u989C\u8272'
              ),
              _react2.default.createElement(
                'div',
                { className: 'row-selection' },
                colorGrups.map(function (color) {
                  return _react2.default.createElement('span', {
                    className: 'color-item ' + (fontColor === color ? 'active' : ''),
                    key: color,
                    style: { backgroundColor: color },
                    onClick: _this5.hanldeOnDanmuku({ fontColor: color })
                  });
                })
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'config-group player-group' },
            _react2.default.createElement(
              'div',
              { className: 'config-item danmuku-opacity' },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u900F\u660E'
              ),
              _react2.default.createElement(
                'div',
                {
                  className: 'row-selection',
                  onMouseMove: this.handleOnOpacityMouseMove,
                  onMouseLeave: this.setOpacity,
                  onMouseUp: this.setOpacity
                },
                _react2.default.createElement(
                  'div',
                  {
                    className: 'opacity-bar',
                    ref: function ref(node) {
                      return _this5.opacityBar = node;
                    },
                    onClick: this.handleOnOpacityBarClick
                  },
                  _react2.default.createElement(
                    'div',
                    {
                      className: 'opacity-bar-level',
                      style: { width: (dragOpacity ? dragOpacityWidth * 100 : opacity * 100) + '%' }
                    },
                    _react2.default.createElement('button', {
                      className: 'opacity-bar-indicator',
                      onMouseDown: this.handleOnIndicatorMouseDown,
                      onMouseUp: this.setOpacity
                    })
                  )
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'config-item player-on-off', 'data-status': '' + (onOff ? 'on' : 'off') },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u5F39\u5E55'
              ),
              _react2.default.createElement(
                'div',
                { className: 'row-selection' },
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name on', onClick: this.setOnOff({ onOff: true }) },
                  '\u5F00'
                ),
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name off', onClick: this.setOnOff({ onOff: false }) },
                  '\u5173'
                )
              )
            ),
            _react2.default.createElement(
              'div',
              { className: 'config-item player-size', 'data-status': 'normal' },
              _react2.default.createElement(
                'span',
                { className: 'row-title' },
                '\u6BD4\u4F8B'
              ),
              _react2.default.createElement(
                'div',
                { className: 'row-selection' },
                _react2.default.createElement(
                  'span',
                  { className: 'selection-name normal' },
                  '16:9'
                )
              )
            )
          )
        )
      )
    );
  };

  return Controller;
}(_react.Component);

Controller.displayName = 'IcePlayerControllerConfig';
Controller.propTypes = {
  danmukuConfig: _react.PropTypes.shape({
    fontColor: _react.PropTypes.string,
    fontSize: _react.PropTypes.oneOf(['small', 'middle', 'large']),
    model: _react.PropTypes.oneOf(['roll', 'top', 'bottom'])
  }),
  playerConfig: _react.PropTypes.shape({
    opacity: _react.PropTypes.number,
    scale: _react.PropTypes.string,
    onOff: _react.PropTypes.bool
  }),

  setDanmukuConfig: _react.PropTypes.func.isRequired,
  setPlayerConfig: _react.PropTypes.func.isRequired
};
var _default = Controller;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(colorGrups, 'colorGrups', 'src/component/controller/Config.js');

  __REACT_HOT_LOADER__.register(Controller, 'Controller', 'src/component/controller/Config.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/controller/Config.js');
}();

;