'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _compute = require('../../util/compute');

var _compute2 = _interopRequireDefault(_compute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Progress = function (_Component) {
  _inherits(Progress, _Component);

  function Progress(props) {
    _classCallCheck(this, Progress);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.getLeft = function () {
      return _this.__getLeft__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processMouseMove = function () {
      return _this.__processMouseMove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processMouseUp = function () {
      return _this.__processMouseUp__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processMouseLeave = function () {
      return _this.__processMouseLeave__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processScrubberMoveDown = function () {
      return _this.__processScrubberMoveDown__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processBarMouseDown = function () {
      return _this.__processBarMouseDown__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processBarMouseUp = function () {
      return _this.__processBarMouseUp__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.processBarClick = function () {
      return _this.__processBarClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.hideProcessMouse = function () {
      return _this.__hideProcessMouse__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.computeLeftX = function () {
      return _this.__computeLeftX__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.state = {
      processMouseLeft: 0,
      processMouseDispaly: false,
      dragProgress: false,
      dragProgressWidth: 0,
      dragVolume: false,
      dragVolumeWidth: 0
    };
    return _this;
  }

  Progress.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    var duration = nextProps.duration,
        currentTime = nextProps.currentTime,
        bufferedTime = nextProps.bufferedTime;

    return duration !== this.props.duration || currentTime !== this.props.currentTime || bufferedTime !== this.props.bufferedTime || nextState !== this.state;
  };

  Progress.prototype.componentWillUnmount = function componentWillUnmount() {
    clearTimeout(this.hideProcessMouseTimer);
  };

  Progress.prototype.__getLeft__REACT_HOT_LOADER__ = function __getLeft__REACT_HOT_LOADER__(element) {
    var left = element.offsetLeft;
    if (element.offsetParent !== null) {
      left += this.getLeft(element.offsetParent);
    }
    return left;
  };

  Progress.prototype.__processMouseMove__REACT_HOT_LOADER__ = function __processMouseMove__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var offsetWidth = this.processBar.offsetWidth;

    var left = this.getLeft(this.processBar);
    var leftX = this.computeLeftX(e.clientX, left, offsetWidth);
    this.setState({
      processMouseLeft: leftX,
      processMouseDispaly: true
    });
    if (this.state.dragProgress) {
      this.setState({
        dragProgressWidth: leftX / offsetWidth * 100
      });
    }
    this.hideProcessMouse();
  };

  Progress.prototype.__processMouseUp__REACT_HOT_LOADER__ = function __processMouseUp__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.state.dragProgress) {
      var time = this.state.dragProgressWidth / 100 * this.props.duration;
      this.props.setCurrentTime(time);
      this.setState({
        dragProgress: false
      });
    }
  };

  Progress.prototype.__processMouseLeave__REACT_HOT_LOADER__ = function __processMouseLeave__REACT_HOT_LOADER__() {
    clearTimeout(this.hideProcessMouseTimer);
    this.setState({
      processMouseDispaly: false,
      dragProgress: false
    });
    if (this.state.dragProgress) {
      var time = this.state.dragProgressWidth / 100 * this.props.duration;
      this.props.setCurrentTime(time);
      this.setState({
        dragProgress: false
      });
    }
  };

  Progress.prototype.__processScrubberMoveDown__REACT_HOT_LOADER__ = function __processScrubberMoveDown__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var offsetWidth = this.processBar.offsetWidth;

    var left = this.getLeft(this.processBar);
    this.setState({
      dragProgress: true,
      dragProgressWidth: this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth * 100
    });
  };

  Progress.prototype.__processBarMouseDown__REACT_HOT_LOADER__ = function __processBarMouseDown__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    e.stopPropagation();
  };

  Progress.prototype.__processBarMouseUp__REACT_HOT_LOADER__ = function __processBarMouseUp__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    e.stopPropagation();
  };

  Progress.prototype.__processBarClick__REACT_HOT_LOADER__ = function __processBarClick__REACT_HOT_LOADER__(e) {
    // 进度条
    e.preventDefault();
    e.stopPropagation();
    var offsetWidth = this.processBar.offsetWidth;

    var left = this.getLeft(this.processBar);
    var time = this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth * this.props.duration;
    this.props.setCurrentTime(time);
  };

  Progress.prototype.__hideProcessMouse__REACT_HOT_LOADER__ = function __hideProcessMouse__REACT_HOT_LOADER__() {
    var _this2 = this;

    clearTimeout(this.hideProcessMouseTimer);
    this.hideProcessMouseTimer = setTimeout(function () {
      _this2.setState({
        processMouseDispaly: false
      });
    }, 1500);
  };

  Progress.prototype.__computeLeftX__REACT_HOT_LOADER__ = function __computeLeftX__REACT_HOT_LOADER__(X, left, width) {
    var leftX = void 0;
    if (X < left) {
      leftX = 0;
    } else if (X > left + width) {
      leftX = width;
    } else {
      leftX = X - left;
    }
    return leftX;
  };

  Progress.prototype.render = function render() {
    var _this3 = this;

    var _props = this.props,
        currentTime = _props.currentTime,
        bufferedTime = _props.bufferedTime,
        duration = _props.duration;
    var _state = this.state,
        processMouseLeft = _state.processMouseLeft,
        processMouseDispaly = _state.processMouseDispaly,
        dragProgress = _state.dragProgress,
        dragProgressWidth = _state.dragProgressWidth;

    return _react2.default.createElement(
      'div',
      { className: 'video-progress', 'aria-label': '\u8FDB\u5EA6\u8F74' },
      _react2.default.createElement(
        'div',
        { className: 'video-time-display' },
        _react2.default.createElement(
          'span',
          { className: 'video-time' },
          (0, _compute2.default)(currentTime)
        )
      ),
      _react2.default.createElement(
        'div',
        {
          className: 'video-progress-bar',
          'aria-label': '\u8FDB\u5EA6\u6761',
          ref: function ref(node) {
            return _this3.processBar = node;
          },
          onMouseMove: this.processMouseMove,
          onMouseLeave: this.processMouseLeave,
          onMouseUp: this.processMouseUp
        },
        _react2.default.createElement(
          'span',
          {
            className: 'video-process-list',
            onClick: this.processBarClick,
            onMouseDown: this.processBarMouseDown,
            onMouseUp: this.processBarMouseUp
          },
          _react2.default.createElement('div', { className: 'video-process-load', style: { width: bufferedTime / duration * 100 + '%' } }),
          _react2.default.createElement('span', {
            className: 'video-process-mouse-display ' + (processMouseDispaly ? 'video-process-mouse-display-show' : ''),
            'data-time': '' + (processMouseDispaly ? (0, _compute2.default)(processMouseLeft / this.processBar.offsetWidth * duration) : 0),
            style: { left: processMouseLeft + 'px' }
          }),
          _react2.default.createElement(
            'div',
            { className: 'video-process-play', style: { width: (dragProgress ? dragProgressWidth : currentTime / duration * 100) + '%' } },
            _react2.default.createElement('button', {
              className: 'video-process-scrubber-indicator',
              onMouseDown: this.processScrubberMoveDown,
              onMouseUp: this.processMouseUp
            })
          )
        )
      ),
      _react2.default.createElement(
        'div',
        { className: 'video-time-display' },
        _react2.default.createElement(
          'span',
          { className: 'video-time' },
          (0, _compute2.default)(duration)
        )
      )
    );
  };

  return Progress;
}(_react.Component);

Progress.displayName = 'IcePlayerControllerProcess';
Progress.propTypes = {
  duration: _react.PropTypes.number.isRequired,
  currentTime: _react.PropTypes.number.isRequired,
  bufferedTime: _react.PropTypes.number.isRequired,
  setCurrentTime: _react.PropTypes.func.isRequired
};
var _default = Progress;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Progress, 'Progress', 'src/component/controller/Progress.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/controller/Progress.js');
}();

;