'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Volume = function (_Component) {
  _inherits(Volume, _Component);

  function Volume(props) {
    _classCallCheck(this, Volume);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.getLeft = function () {
      return _this.__getLeft__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.setVolume = function () {
      return _this.__setVolume__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnVolumeIndicatorMouseDown = function () {
      return _this.__handleOnVolumeIndicatorMouseDown__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnVolumeMouseMove = function () {
      return _this.__handleOnVolumeMouseMove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnVolumeBarClick = function () {
      return _this.__handleOnVolumeBarClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleOnVolumeIconClick = function () {
      return _this.__handleOnVolumeIconClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.computeLeftX = function () {
      return _this.__computeLeftX__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.state = {
      dragVolume: false,
      dragVolumeWidth: 0
    };
    return _this;
  }

  Volume.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
    var volume = nextProps.volume,
        muted = nextProps.muted;

    return volume !== this.props.volume || muted !== this.props.muted;
  };

  Volume.prototype.__getLeft__REACT_HOT_LOADER__ = function __getLeft__REACT_HOT_LOADER__(element) {
    var left = element.offsetLeft;
    if (element.offsetParent !== null) {
      left += this.getLeft(element.offsetParent);
    }
    return left;
  };

  Volume.prototype.__setVolume__REACT_HOT_LOADER__ = function __setVolume__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.state.dragVolume) {
      this.setState({
        dragVolume: false
      });
    }
  };

  Volume.prototype.__handleOnVolumeIndicatorMouseDown__REACT_HOT_LOADER__ = function __handleOnVolumeIndicatorMouseDown__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var offsetWidth = this.volumeBar.offsetWidth;

    var left = this.getLeft(this.volumeBar);
    var result = this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth;
    this.setState({
      dragVolume: true,
      dragVolumeWidth: result
    });
  };

  Volume.prototype.__handleOnVolumeMouseMove__REACT_HOT_LOADER__ = function __handleOnVolumeMouseMove__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    if (this.state.dragVolume) {
      var offsetWidth = this.volumeBar.offsetWidth;

      var left = this.getLeft(this.volumeBar);
      var result = this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth;
      this.setState({
        dragVolumeWidth: result
      });
      this.props.setVolume(result);
    }
  };

  Volume.prototype.__handleOnVolumeBarClick__REACT_HOT_LOADER__ = function __handleOnVolumeBarClick__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    e.stopPropagation();
    var offsetWidth = this.volumeBar.offsetWidth;

    var left = this.getLeft(this.volumeBar);
    this.props.setVolume(this.computeLeftX(e.clientX, left, offsetWidth) / offsetWidth);
  };

  Volume.prototype.__handleOnVolumeIconClick__REACT_HOT_LOADER__ = function __handleOnVolumeIconClick__REACT_HOT_LOADER__(e) {
    e.preventDefault();
    var flag = void 0;
    if (this.props.muted) {
      flag = false;
    } else {
      flag = true;
    }
    this.props.setMuted(flag);
  };

  Volume.prototype.__computeLeftX__REACT_HOT_LOADER__ = function __computeLeftX__REACT_HOT_LOADER__(X, left, width) {
    var leftX = void 0;
    if (X < left) {
      leftX = 0;
    } else if (X > left + width) {
      leftX = width;
    } else {
      leftX = X - left;
    }
    return leftX;
  };

  Volume.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        volume = _props.volume,
        muted = _props.muted;
    var _state = this.state,
        dragVolume = _state.dragVolume,
        dragVolumeWidth = _state.dragVolumeWidth;

    var volumeHtml = '<use class="video-svg-volume video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_volume" /><use class="video-svg-volume-damping video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_volume_damping" /><use class="video-svg-volume-mute video-svg-symbol-hidden" xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="#video_volume_mute" />';
    var volumeStatus = '';
    if (volume >= 0.5) {
      volumeStatus = 'normal';
    } else if (volume < 0.5 && volume > 0) {
      volumeStatus = 'damping';
    } else {
      volumeStatus = 'mute';
    }
    if (muted) {
      volumeStatus = 'mute';
    }
    return _react2.default.createElement(
      'div',
      {
        className: 'video-control-item video-btn-volume',
        'aria-label': '\u97F3\u91CF',
        'data-status': volumeStatus,
        onMouseMove: this.handleOnVolumeMouseMove,
        onMouseLeave: this.setVolume,
        onMouseUp: this.setVolume
      },
      _react2.default.createElement('svg', {
        className: 'video-svg',
        version: '1.1',
        viewBox: '0 0 24 24',
        dangerouslySetInnerHTML: { __html: volumeHtml },
        onClick: this.handleOnVolumeIconClick
      }),
      _react2.default.createElement(
        'div',
        {
          className: 'video-btn-volume-bar',
          ref: function ref(node) {
            return _this2.volumeBar = node;
          },
          onClick: this.handleOnVolumeBarClick
        },
        _react2.default.createElement(
          'div',
          {
            className: 'video-btn-volume-bar-level',
            style: { width: (dragVolume ? dragVolumeWidth * 100 : volume * 100) + '%' }
          },
          _react2.default.createElement('button', {
            className: 'video-btn-volume-bar-indicator',
            onMouseDown: this.handleOnVolumeIndicatorMouseDown,
            onMouseUp: this.setVolume
          })
        )
      )
    );
  };

  return Volume;
}(_react.Component);

Volume.displayName = 'IcePlayerControllerVolume';
Volume.propTypes = {
  volume: _react.PropTypes.number.isRequired,
  muted: _react.PropTypes.bool.isRequired,
  setVolume: _react.PropTypes.func.isRequired,
  setMuted: _react.PropTypes.func.isRequired
};
var _default = Volume;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Volume, 'Volume', 'src/component/controller/Volume.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/component/controller/Volume.js');
}();

;