'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DanmukuCanvas = function () {
  function DanmukuCanvas(canvas, duration) {
    var _this = this;

    _classCallCheck(this, DanmukuCanvas);

    this.clearCanvas = function () {
      return _this.__clearCanvas__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.fixCanvas = function () {
      return _this.__fixCanvas__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.resize = function () {
      return _this.__resize__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getFont = function () {
      return _this.__getFont__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.draw = function () {
      return _this.__draw__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.refreshDanmuku = function () {
      return _this.__refreshDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.formatData = function () {
      return _this.__formatData__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addDanmuku = function () {
      return _this.__addDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.insertDanmuku = function () {
      return _this.__insertDanmuku__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.stop = function () {
      return _this.__stop__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isSupport = true;
    if (!canvas.getContext) {
      this.isSupport = false;
      console.warn('浏览器不支持canvas');
      return;
    }
    var container = canvas.parentNode;
    if (!this.canvasWidth) {
      // 父容器大小
      var w = container.clientWidth;
      var h = container.clientHeight;
      this.canvasWidth = w;
      this.canvasHeight = h;
      canvas.width = w;
      canvas.height = h;
      canvas.style.width = w;
      canvas.style.height = h;
    }
    var ctx = canvas.getContext('2d');
    this.fixCanvas(canvas);
    this.ctx = ctx;
    this.canvas = canvas;
    this.duration = duration;
    this.clearCanvas();
    this.danmukuArr = [];
    this.col = Math.floor(canvas.height / 30);
    this.colTop = parseInt(this.col * 2 / 3, 10);
    this.cols = new Array(this.col).fill(true);
    this.topCols = new Array(this.col).fill(true);
    this.bottomCols = new Array(this.col).fill(true);
  }

  DanmukuCanvas.prototype.__clearCanvas__REACT_HOT_LOADER__ = function __clearCanvas__REACT_HOT_LOADER__() {
    this.ctx.clearRect(0, 0, this.canvasWidth, this.canvasHeight);
  };

  DanmukuCanvas.prototype.__fixCanvas__REACT_HOT_LOADER__ = function __fixCanvas__REACT_HOT_LOADER__(t) {
    var i = t.getContext('2d');
    var n = window.devicePixelRatio || 1;
    var e = i.webkitBackingStorePixelRatio || i.mozBackingStorePixelRatio || i.msBackingStorePixelRatio || i.oBackingStorePixelRatio || i.backingStorePixelRatio || 1;
    var a = n / e;
    if (n !== e) {
      var o = t.width;
      var r = t.height;
      t.width = o * a;
      t.height = r * a;
      this.canvasWidth = o * a;
      this.canvasHeight = o * a;
      t.style.width = o + 'px';
      t.style.height = r + 'px';
      i.scale(a, a);
    }
    this.scale = a;
  };

  DanmukuCanvas.prototype.__resize__REACT_HOT_LOADER__ = function __resize__REACT_HOT_LOADER__(canvas) {
    var container = canvas.parentNode;
    var w = container.clientWidth;
    var h = container.clientHeight;
    this.canvasWidth = w;
    this.canvasHeight = h;
    canvas.width = w;
    canvas.height = h;
    canvas.style.width = w;
    canvas.style.height = h;
    this.fixCanvas(canvas);
    this.col = Math.floor(canvas.height / 30);
    this.colTop = parseInt(this.col * 2 / 3, 10);
    this.cols = new Array(this.col).fill(true);
    this.topCols = new Array(this.col).fill(true);
    this.bottomCols = new Array(this.col).fill(true);
  };

  DanmukuCanvas.prototype.__getFont__REACT_HOT_LOADER__ = function __getFont__REACT_HOT_LOADER__(size) {
    var ratio = void 0;
    switch (size) {
      case 'small':
        ratio = '14';
        break;
      case 'middle':
        ratio = '20';
        break;
      case 'large':
        ratio = '26';
        break;
      default:
        ratio = '20';
        break;
    }
    return ratio + 'px Arial normal';
  };

  DanmukuCanvas.prototype.__draw__REACT_HOT_LOADER__ = function __draw__REACT_HOT_LOADER__() {
    var _this2 = this;

    if (!this.isSupport) {
      return;
    }
    if (this.timer) {
      return;
    }
    this.timer = setInterval(function () {
      _this2.clearCanvas();
      _this2.ctx.save();
      var arr = _this2.danmukuArr;
      for (var i = 0, len = arr.length; i < len; i += 1) {
        if (arr[i].status) {
          var _arr$i = arr[i],
              content = _arr$i.content,
              x = _arr$i.x,
              y = _arr$i.y;

          _this2.ctx.fillStyle = arr[i].fontColor;
          _this2.ctx.font = _this2.getFont(arr[i].fontSize);
          _this2.ctx.fillText(content, x, y);
          if (arr[i].insert) {
            _this2.ctx.strokeStyle = 'white';
            _this2.ctx.lineCap = 'square';
            _this2.ctx.beginPath();
            _this2.ctx.moveTo(x, y + 3);
            _this2.ctx.lineTo(x + arr[i].textWidth / _this2.scale, y + 3);
            _this2.ctx.stroke();
            _this2.ctx.closePath();
          }
          switch (arr[i].model) {
            case 'roll':
              _this2.danmukuArr[i].x = arr[i].x - arr[i].speed;
              if (arr[i].x <= -arr[i].textWidth) {
                _this2.danmukuArr[i].status = false;
              }
              if (arr[i].x + arr[i].textWidth < _this2.canvas.width * (4 / 5) && arr[i].status) {
                _this2.cols[arr[i].col - 1] = true;
              }
              break;
            case 'top':
              _this2.danmukuArr[i].current = _this2.danmukuArr[i].current + 30;
              if (arr[i].current >= _this2.duration) {
                _this2.danmukuArr[i].status = false;
                _this2.topCols[arr[i].col - 1] = true;
              }
              break;
            case 'bottom':
              _this2.danmukuArr[i].current = _this2.danmukuArr[i].current + 30;
              if (arr[i].current >= _this2.duration) {
                _this2.danmukuArr[i].status = false;
                _this2.bottomCols[_this2.bottomCols.length - arr[i].col] = true;
              }
              break;
            default:
              _this2.danmukuArr[i].x = arr[i].x - arr[i].speed;
              if (arr[i].x <= -arr[i].textWidth) {
                _this2.danmukuArr[i].status = false;
              }
              if (arr[i].x + arr[i].textWidth < _this2.canvasWidth - 33 && arr[i].status) {
                _this2.cols[arr[i].col - 1] = true;
              }
              break;
          }
        }
      }
      _this2.ctx.restore();
      _this2.refreshDanmuku();
    }, 30);
  };

  DanmukuCanvas.prototype.__refreshDanmuku__REACT_HOT_LOADER__ = function __refreshDanmuku__REACT_HOT_LOADER__() {
    for (var i = 0; i < this.danmukuArr.length; i += 1) {
      if (!this.danmukuArr[i].status) {
        this.danmukuArr.splice(i, 1);
      }
    }
  };

  DanmukuCanvas.prototype.__formatData__REACT_HOT_LOADER__ = function __formatData__REACT_HOT_LOADER__(data, insertFlag) {
    var positionX = void 0;
    var randomCol = void 0;
    var cols = this.cols;
    var topCols = this.topCols;
    var bottomCols = this.bottomCols;
    this.ctx.font = this.getFont(data.fontSize);
    var scale = this.scale;
    var tw = this.ctx.measureText(data.content).width * scale;
    var distance = tw + this.canvas.width;
    if (data.model === 'roll') {
      for (var i = 0; i < cols.length; i += 1) {
        if (cols[i]) {
          randomCol = i + 1;
          this.cols[i] = false;
          break;
        }
        if (i === cols.length - 1) {
          var random = parseInt(Math.random() * (this.col - 1) + 1, 10);
          randomCol = random;
          this.cols[random - 1] = false;
        }
      }
      positionX = this.canvas.width / scale;
    } else if (data.model === 'top') {
      for (var _i = 0; _i < topCols.length; _i += 1) {
        if (topCols[_i]) {
          randomCol = _i + 1;
          this.topCols[_i] = false;
          break;
        }
        if (_i === topCols.length - 1) {
          var _random = parseInt(Math.random() * (this.col - 1) + 1, 10);
          randomCol = _random;
          this.topCols[_random - 1] = false;
        }
      }
      positionX = (this.canvas.width - tw) / 2 / scale;
    } else if (data.model === 'bottom') {
      var len = bottomCols.length;
      for (var _i2 = 0; _i2 < len; _i2 += 1) {
        if (bottomCols[_i2]) {
          randomCol = len - _i2;
          this.bottomCols[_i2] = false;
          break;
        }
        if (_i2 === topCols.length - 1) {
          var _random2 = parseInt(Math.random() * (this.col - 1) + 1, 10);
          randomCol = _random2;
          this.bottomCols[_random2 - 1] = false;
        }
      }
      positionX = (this.canvas.width - tw) / 2 / scale;
    }
    var danmukuData = _extends({}, data, {
      x: positionX,
      y: randomCol * 30,
      textWidth: tw,
      speed: distance / scale / (this.duration / 1000 * 33),
      insert: insertFlag,
      current: 0,
      status: true,
      col: randomCol
    });
    return danmukuData;
  };

  DanmukuCanvas.prototype.__addDanmuku__REACT_HOT_LOADER__ = function __addDanmuku__REACT_HOT_LOADER__(data) {
    var _this3 = this;

    var newDanmuku = data.map(function (d) {
      var danmukuData = _this3.formatData(d, false);
      return danmukuData;
    });
    this.danmukuArr = this.danmukuArr.concat(newDanmuku);
  };

  DanmukuCanvas.prototype.__insertDanmuku__REACT_HOT_LOADER__ = function __insertDanmuku__REACT_HOT_LOADER__(danmu) {
    var data = this.formatData(danmu, true);
    this.danmukuArr.push(data);
  };

  DanmukuCanvas.prototype.__stop__REACT_HOT_LOADER__ = function __stop__REACT_HOT_LOADER__() {
    clearInterval(this.timer);
    this.timer = null;
  };

  return DanmukuCanvas;
}();

var _default = DanmukuCanvas;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(DanmukuCanvas, 'DanmukuCanvas', 'src/util/Canvas.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/util/Canvas.js');
}();

;